/* -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */
/*
 * Copyright (C) 2001-2002 CodeFactory AB
 * Copyright (C) 2001-2002 Richard Hult <rhult@codefactory.se>
 * Copyright (C) 2001-2002 Mikael Hallendal <micke@codefactory.se>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef __MRP_INTERVAL_H__
#define __MRP_INTERVAL_H__

#include <mrproject/mrp-time.h>

typedef struct _MrpInterval MrpInterval;

typedef enum {
	MRP_INTERVAL_TYPE_NONWORK,
	MRP_INTERVAL_TYPE_WORK
} MrpIntervalType;

MrpInterval *     mrp_interval_new                (mrptime          start,
						   mrptime          end,
						   MrpIntervalType  type);

void              mrp_interval_free               (MrpInterval     *interval);

MrpInterval *     mrp_interval_copy               (MrpInterval     *interval);

MrpInterval *     mrp_interval_ref                (MrpInterval     *interval);
void              mrp_interval_unref              (MrpInterval     *interval);

gboolean          mrp_interval_includes           (MrpInterval     *interval,
						   mrptime          time);
gboolean          mrp_interval_intersects         (MrpInterval     *interval1,
						   MrpInterval     *interval2);
void              mrp_interval_get_absolute       (MrpInterval     *interval,
						   mrptime          offset,
						   mrptime         *start,
						   mrptime         *end);
MrpIntervalType   mrp_interval_get_type           (MrpInterval     *interval);

#endif /* __MRP_INTERVAL_H__ */
